import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Background here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Background extends World
{
    private int timer = 0;
    private Scene scene = Scene.MAZE;
    private Switcher s = new Switcher();

    public Background()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(1000, 600, 1); 

        switchScene();
    }

    public void act() {
        timer++;
        if (scene == Scene.PLATFORM && timer % 30 == 0 && Greenfoot.getRandomNumber(4) == 0) {
            addObject(new Ball(), getWidth(), 0);
        }
    }

    public int timer() {
        return timer;
    }

    public void switchScene() {
        removeObjects(getObjects(null));
        switch (scene) {
            case ROCKS:
            scene = Scene.MAZE;
            initMaze();
            break;
            case MAZE:
            scene = Scene.PLATFORM;
            initPlatform();
            break;
            case PLATFORM:
            scene = Scene.ROCKS;
            initRocks();
            break;
        }
        addObject(s, s.getImage().getWidth()/2, s.getImage().getHeight()/2);
    }

    public void initRocks() {
        addObject(new Rocket(), getWidth()/8, getHeight()/2);
        int edge = 30;
        int numRocks = 20;
        while (numRocks > 0) {
            int x = edge + Greenfoot.getRandomNumber(getWidth() - edge*2);
            int y = edge + Greenfoot.getRandomNumber(getHeight() - edge*2);
            if (getObjectsAt(x, y, null).size() < 1) {
                addObject(new Rock(), x, y);
                numRocks--;
            }
        }
    }

    public void initMaze() {
        Floor f = new Floor();
        int pWidth = f.getImage().getWidth();
        int pDepth = f.getImage().getHeight();
        int across = getWidth()/pWidth;
        for (int j = 0; j < across; j++) {
            addObject(new Floor(), j * pWidth + pWidth/2, pDepth/2-3);
            addObject(new Floor(), j * pWidth + pWidth/2, getHeight()-pDepth/2);
        }
        addObject(new Wall(), 10, 140);
        addObject(new Wall(), 10, 455);
        addObject(new Wall(), 990, 455);
        addObject(new Wall(), 990, 142);
        placeInternalWalls();
        placeFood();
        addObject(new Bug(), 30, 300);
    }

    public void placeFood() {
        int gap = 30;
        for (int i = 0; i < getWidth(); i+= gap) {
            for (int j = 0; j < getHeight(); j += gap) {
                addObject(new Food(), i, j);
            }
        }
    }

    public void placeInternalWalls() {
        addObject(new Wall(), 100, 322);
        addObject(new Floor(), 215, 189);
        addObject(new Floor(), 215, 457);
        addObject(new Wall(), 349, 396);
        addObject(new Floor(), 301, 272);
        addObject(new Floor(), 234, 523);
        addObject(new Floor(), 301, 114);
        addObject(new Wall(), 436, 229);
        addObject(new Floor(), 551, 364);
        addObject(new Floor(), 632, 297);
        addObject(new Wall(), 517, 181);
        addObject(new Wall(), 748, 414);
        addObject(new Floor(), 651, 66);
        addObject(new Floor(), 616, 529);
        addObject(new Floor(), 729, 136);
        addObject(new Floor(), 730, 214);
        addObject(new Wall(), 864, 142);
        addObject(new Wall(), 864, 391);
        addObject(new Floor(), 483, 457);
    }

    public void initPlatform() {
        Platform p = new Platform();
        int pWidth = p.getImage().getWidth();
        int pDepth = p.getImage().getHeight();
        int levels = 6;
        int across = getWidth()/pWidth;
        for (int i = 1; i <= levels; i++) {
            int y = getHeight()/levels*i - pDepth/2;
            int offset = (i % 2 == 0) ? 0 : pWidth;
            for (int j = 0; j < across; j++) {
                addObject(new Platform(), j * pWidth + offset, y);
            }
        }
        removeObjects(getObjectsAt(500, 390, null));
        addObject(new SmallPlatform(150),500, 390);
        removeObjects(getObjectsAt(0, 190, null));
        removeObjects(getObjectsAt(250, 190, null));
        addObject(new SmallPlatform(280), 180, 190);
        addObject(new Player(), 835, 560);
    }
}
