import greenfoot.*;

/**
 * Write a description of class Bouncer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bouncer extends Shootable
{
    protected int fallSpeed = 0;
    protected int gravity = 2;
    protected int jumpSpeed = 25;
    protected boolean bounce = false;
    protected int moveSpeedLimit = 25;
    
    public void moveVertical() {
        int below = belowDistance();
        int above = aboveDistance();
        fallSpeed += gravity;
        if (fallSpeed > 0 && below < fallSpeed) { // falling and something close
            setLocation(getX(), getY() + below);
            fallSpeed = bounce ? -(Math.max((int)(fallSpeed *.75), jumpSpeed)) : 0;
        } else if (fallSpeed < 0 && above > fallSpeed) { // jumping and something close
            setLocation(getX(), getY() + above);
            fallSpeed += gravity;
        } else {
            setLocation(getX(), getY()+fallSpeed);
        }
    }
        
    public void jump() {
        if (belowDistance() == 0) {
            fallSpeed = -jumpSpeed;
            moveVertical();
        }
    }
    
    public int belowDistance() {
        int distance = 1;
        while (true) {
            int y = getY() + getImage().getHeight()/2 + distance;
            if (y >= getWorld().getHeight() ||
                  getWorld().getObjectsAt(getX(), y, null).size() > 0) {
               return distance-1;
            }
            distance++;
        }
    }
    
    public int aboveDistance() {
        int distance = 1;
        while (true) {
            int y = getY() - getImage().getHeight()/2 - distance;
            if (y <= 0 ||
                  getWorld().getObjectsAt(getX(), y, null).size() > 0) {
               return -(distance-1);
            }
            distance++;
        }
    }       
}

