import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Bullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bullet extends Actor
{
    private int xSpeed = 15, ySpeed = 15;
    private int buffer = 0;
    private Direction direction;
    private boolean inWorld = true;
    private Actor shooter;
    
    public Bullet(Actor shooter, Direction direction) {
        GreenfootImage img = new GreenfootImage(6,6);
        img.fillOval(0, 0, 5, 5);
        setImage(img);
        this.shooter = shooter;
        this.direction = direction;
    }
    
    public void act() 
    {
       tryMove();
       if (inWorld) {
           checkHit();
       }
    }
    
    public void tryMove() {
       int newX = getX(), newY = getY();
        switch (direction) {
            case LEFT:
            newX = getX() - xSpeed;
            break;
            case RIGHT:
            newX = getX() + xSpeed;
            break;
            case UP:
            newY = getY() - ySpeed;
            break;
            case DOWN:
            newY = getY() + ySpeed;
            break;
        }
        if (newX > buffer && newX < getWorld().getWidth() - buffer &&
                newY > buffer && newY < getWorld().getHeight() - buffer) {
            setLocation(newX, newY);
        } else {
            getWorld().removeObject(this);
            inWorld = false;
        }
    }
    
    public void checkHit() {
        Actor target = getOneIntersectingObject(Shootable.class);
        if (target != null && target != shooter) {
            getWorld().removeObject(target);
            getWorld().removeObject(this);
        }
    }
}
