import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Rocket here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Rocket extends Actor
{
    private GreenfootImage leftImg = new GreenfootImage("rocket-left.png");
    private GreenfootImage rightImg = new GreenfootImage("rocket-right.png");
    private GreenfootImage upImg = new GreenfootImage("rocket-up.png");
    private GreenfootImage downImg = new GreenfootImage("rocket-down.png");

    private Direction direction = Direction.RIGHT;

    private int xSpeed = 5, ySpeed = 5;
    private int buffer = 45; // how close to go to edge of world
    private int pad = 10; // how close to go to objects

    public void act() {
        if (checkKeys()) {
            updateImage();
        }
        tryMove();
    }

    public void updateImage() {
        switch (direction) {
            case LEFT:
            setImage(leftImg);
            break;
            case RIGHT:
            setImage(rightImg);
            break;
            case UP:
            setImage(upImg);
            break;
            case DOWN:
            setImage(downImg);
            break;
        }
    }

    public boolean checkKeys() {
        if (Greenfoot.isKeyDown("space")) {
            fireBullet();
        }
        if (Greenfoot.isKeyDown("left")) {
            direction = Direction.LEFT;
        } else if (Greenfoot.isKeyDown("right")) {
            direction = Direction.RIGHT;
        } else if (Greenfoot.isKeyDown("up")) {
            direction = Direction.UP;
        } else if (Greenfoot.isKeyDown("down")) {
            direction = Direction.DOWN;
        } else {
            return false;
        }
        return true;
    }

    public void tryMove() {
        int newX = getX(), newY = getY();
        switch (direction) {
            case LEFT:
            newX = getX() - xSpeed;
            break;
            case RIGHT:
            newX = getX() + xSpeed;
            break;
            case UP:
            newY = getY() - ySpeed;
            break;
            case DOWN:
            newY = getY() + ySpeed;
            break;
        }
        Actor thing = getOneObjectAtOffset((newX - getX()) * pad, (newY - getY()) * pad, Rock.class);
        if (thing != null) {
            ((Rock) thing).bounce(this);
        }
        if (newX > buffer && newX < getWorld().getWidth() - buffer &&
                newY > buffer && newY < getWorld().getHeight() - buffer && thing == null) {
            setLocation(newX, newY);
        }
    }
        
    public void fireBullet() {
        int timer = ((Background) getWorld()).timer();
        int bulletCount = getWorld().getObjects(Bullet.class).size();
        if (timer % 10 == 0 || bulletCount == 0) {
            getWorld().addObject(new Bullet(this, direction), getX(), getY());
        }
    }
}
