import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class SmallPlatform here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SmallPlatform extends Actor
{
    private int minX, maxX;
    private int distance;
    private Direction direction = Direction.LEFT;
    private int speed = 2;
    
    public SmallPlatform(int distance) {
        this.distance = distance/2;
    }
    
    protected void addedToWorld(World world) {
        minX = getX() - distance;
        maxX = getX() + distance;
    }
    
    public void act() 
    {
        int newX = getX();
        switch (direction) {
            case LEFT:
            if (getX() - speed > minX) {
                newX = getX() - speed;
            } else {
                direction = Direction.RIGHT;
            }
            break;
            case RIGHT:
            if (getX() + speed < maxX) {
                newX = getX() + speed;
            } else {
                direction = Direction.LEFT;
            }
            break;
        }
        List nearMe = thingsNearMe();
        for (Object o : nearMe) {
            Actor a = (Actor) o;
            if (onMe(a)) {
                a.setLocation(a.getX() + (direction == Direction.LEFT ? -speed : speed), a.getY());
            } else {
                //System.out.printf("%s, %s not on: %s,%s\n", a.getX(), a.getY(), getX(), getY());
            }
        }
        setLocation(newX, getY());
    }
    
    public List thingsNearMe() {
        List objs = getObjectsInRange(getImage().getWidth() + getImage().getHeight(), null);
        for (int i = 0; i < objs.size(); i++) {
            if (objs.get(i) instanceof Platform) {
                objs.remove(i);
            }
        }
        return objs;
    }
    
    public boolean onMe(Actor a) {
        int dY = getY() - a.getY() - a.getImage().getHeight()/2 - getImage().getHeight()/2;
        return (dY > -1 && dY < 5);
    }
        
}
